#!/bin/bash

#
# lxc: linux Container library

# Authors:
# Daniel Lezcano <daniel.lezcano@free.fr>

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

# Detect use under userns (unsupported)
for arg in "$@"; do
    [ "$arg" = "--" ] && break
    if [ "$arg" = "--mapped-uid" ] || [ "$arg" = "--mapped-gid" ]; then
        echo "This template can't be used for unprivileged containers." 1>&2
        echo "You may want to try the \"download\" template instead." 1>&2
        exit 1
    fi
done

# Make sure the usual locations are in PATH
export PATH=$PATH:/usr/sbin:/usr/bin:/sbin:/bin

MIRROR="${MIRROR:-http://http.debian.net/debian}"
LOCALSTATEDIR="/var"
LXC_TEMPLATE_CONFIG="/usr/share/lxc/config"

configure_debian()
{
    rootfs=$1
    hostname=$2

    # squeeze only has /dev/tty and /dev/tty0 by default,
    # therefore creating missing device nodes for tty1-4.
    for tty in $(seq 1 4); do
        if [ ! -e "$rootfs/dev/tty$tty" ]; then
            mknod "$rootfs/dev/tty$tty" c 4 "$tty"
        fi
    done

    # configure the inittab
    cat <<EOF > "$rootfs/etc/inittab"
id:3:initdefault:
si::sysinit:/etc/init.d/rcS
l0:0:wait:/etc/init.d/rc 0
l1:1:wait:/etc/init.d/rc 1
l2:2:wait:/etc/init.d/rc 2
l3:3:wait:/etc/init.d/rc 3
l4:4:wait:/etc/init.d/rc 4
l5:5:wait:/etc/init.d/rc 5
l6:6:wait:/etc/init.d/rc 6
# Normally not reached, but fallthrough in case of emergency.
z6:6:respawn:/sbin/sulogin
1:2345:respawn:/sbin/getty 38400 console
c1:12345:respawn:/sbin/getty 38400 tty1 linux
c2:12345:respawn:/sbin/getty 38400 tty2 linux
c3:12345:respawn:/sbin/getty 38400 tty3 linux
c4:12345:respawn:/sbin/getty 38400 tty4 linux
p6::ctrlaltdel:/sbin/init 6
p0::powerfail:/sbin/init 0
EOF

    # symlink mtab
    [ -e "$rootfs/etc/mtab" ] && rm "$rootfs/etc/mtab"
    ln -s /proc/self/mounts "$rootfs/etc/mtab"

    # disable selinux in debian
    mkdir -p "$rootfs/selinux"
    echo 0 > "$rootfs/selinux/enforce"

    # configure the network using the dhcp
    cat <<EOF > "$rootfs/etc/network/interfaces"
auto lo
iface lo inet loopback

auto eth0
iface eth0 inet dhcp
EOF

    # set the hostname
    cat <<EOF > "$rootfs/etc/hostname"
$hostname
EOF

    # reconfigure some services
    if [ -z "$LANG" ]; then
        chroot "$rootfs" locale-gen en_US.UTF-8 UTF-8
        chroot "$rootfs" update-locale LANG=en_US.UTF-8
    else
        encoding=$(echo "$LANG" | cut -d. -f2)
        chroot "$rootfs" sed -e "s/^# \(${LANG} ${encoding}\)/\1/" \
            -i /etc/locale.gen 2> /dev/null
        chroot "$rootfs" locale-gen "$LANG" "$encoding"
        chroot "$rootfs" update-locale LANG="$LANG"
    fi

    # remove pointless services in a container
    chroot "$rootfs" /usr/sbin/update-rc.d -f checkroot.sh disable
    chroot "$rootfs" /usr/sbin/update-rc.d -f umountfs disable
    chroot "$rootfs" /usr/sbin/update-rc.d -f hwclock.sh disable
    chroot "$rootfs" /usr/sbin/update-rc.d -f hwclockfirst.sh disable

    # generate new SSH keys
    if [ -x "$rootfs/var/lib/dpkg/info/openssh-server.postinst" ]; then
        cat > "$rootfs/usr/sbin/policy-rc.d" << EOF
#!/bin/sh
exit 101
EOF
        chmod +x "$rootfs/usr/sbin/policy-rc.d"

        if [ -f "$rootfs/etc/init/ssh.conf" ]; then
            mv "$rootfs/etc/init/ssh.conf" "$rootfs/etc/init/ssh.conf.disabled"
        fi

        # shellcheck disable=SC2086
        rm -f $rootfs/etc/ssh/ssh_host_*key*

        DPKG_MAINTSCRIPT_PACKAGE=openssh DPKG_MAINTSCRIPT_NAME=postinst chroot "$rootfs" /var/lib/dpkg/info/openssh-server.postinst configure
        # shellcheck disable=SC2086
        sed -i "s/root@$(hostname)/root@$hostname/g" $rootfs/etc/ssh/ssh_host_*.pub

	# Don't allow root login with password
	sed -i "s/PermitRootLogin yes/PermitRootLogin without-password/" "$rootfs/etc/ssh/sshd_config"

        if [ -f "$rootfs/etc/init/ssh.conf.disabled" ]; then
            mv "$rootfs/etc/init/ssh.conf.disabled" "$rootfs/etc/init/ssh.conf"
        fi

        rm -f "$rootfs/usr/sbin/policy-rc.d"
    fi

    # set initial timezone as on host
    if [ -f /etc/timezone ]; then
        cat /etc/timezone > "$rootfs/etc/timezone"
        chroot "$rootfs" dpkg-reconfigure -f noninteractive tzdata
    elif [ -f /etc/sysconfig/clock ]; then
        # shellcheck disable=SC1091
        . /etc/sysconfig/clock
        echo "$ZONE" > "$rootfs/etc/timezone"
        chroot "$rootfs" dpkg-reconfigure -f noninteractive tzdata
    else
        echo "Timezone in container is not configured. Adjust it manually."
    fi

    password="$(dd if=/dev/urandom bs=6 count=1 2> /dev/null | base64)"

    echo "root:$password" | chroot "$rootfs" chpasswd
    echo "Root password is '$password', please change !"

    return 0
}

configure_debian_systemd()
{
    path=$1
    rootfs=$2

    init="$(chroot "${rootfs}" dpkg-query --search /sbin/init | cut -d : -f 1)"
    if [ "$init" = "systemd-sysv" ]; then
       # only appropiate when systemd is PID 1
       echo 'lxc.autodev = 1' >> "$path/config"
       echo 'lxc.kmsg = 0' >> "$path/config"
    fi

    # this only works if we have getty@.service to manipulate
    if [ -f "${rootfs}/lib/systemd/system/getty\@.service" ]; then
       sed -e 's/^ConditionPathExists=/# ConditionPathExists=/' \
           -e 's/After=dev-%i.device/After=/' \
           < "${rootfs}/lib/systemd/system/getty\@.service" \
           > "${rootfs}/etc/systemd/system/getty\@.service"
    fi

    # just in case systemd is not installed
    # shellcheck disable=SC2086
    mkdir -p ${rootfs}/{lib,etc}/systemd/system
    mkdir -p "${rootfs}/etc/systemd/system/getty.target.wants"

    # This function has been copied and adapted from lxc-fedora
    rm -f "${rootfs}/etc/systemd/system/default.target"
    touch "${rootfs}/etc/fstab"
    chroot "${rootfs}" ln -s /dev/null /etc/systemd/system/systemd-udevd.service
    chroot "${rootfs}" ln -s /lib/systemd/system/multi-user.target /etc/systemd/system/default.target
    # Make systemd honor SIGPWR
    chroot "${rootfs}" ln -s /lib/systemd/system/halt.target /etc/systemd/system/sigpwr.target
    # Setup getty service on the 4 ttys we are going to allow in the
    # default config.  Number should match lxc.tty
    ( cd "${rootfs}/etc/systemd/system/getty.target.wants" || return 1
        for i in 1 2 3 4 ; do ln -sf ../getty\@.service getty@tty${i}.service; done )

    return 0
}

cleanup()
{
    rm -rf "$cache/partial-$release-$arch"
    rm -rf "$cache/rootfs-$release-$arch"
}

download_debian()
{
    case "$release" in
      squeeze|wheezy)
        init=sysvinit
        ;;
      *)
        init=init
        ;;
    esac
    packages=\
$init,\
ifupdown,\
locales,\
libui-dialog-perl,\
dialog,\
isc-dhcp-client,\
netbase,\
net-tools,\
iproute,\
openssh-server

    cache="$1"
    arch="$2"
    release="$3"

    trap cleanup EXIT SIGHUP SIGINT SIGTERM
    # check the mini debian was not already downloaded
    mkdir -p "$cache/partial-$release-$arch"
    # shellcheck disable=SC2181
    if [ $? -ne 0 ]; then
        echo "Failed to create '$cache/partial-$release-$arch' directory"
        return 1
    fi

    # download a mini debian into a cache
    echo "Downloading debian minimal ..."
    debootstrap --verbose --variant=minbase --arch="$arch" \
        --include="$packages" \
        "$release" "$cache/partial-$release-$arch" "$MIRROR"
    # shellcheck disable=SC2181
    if [ $? -ne 0 ]; then
        echo "Failed to download the rootfs, aborting."
        return 1
    fi

    mv "$1/partial-$release-$arch" "$1/rootfs-$release-$arch"
    echo "Download complete."
    trap EXIT
    trap SIGINT
    trap SIGTERM
    trap SIGHUP

    return 0
}

copy_debian()
{
    cache=$1
    arch=$2
    rootfs=$3
    release=$4

    # make a local copy of the minidebian
    echo -n "Copying rootfs to $rootfs..."
    mkdir -p "$rootfs"
    rsync -Ha "$cache/rootfs-$release-$arch"/ "$rootfs/" || return 1
    return 0
}

install_debian()
{
    cache="$LOCALSTATEDIR/cache/lxc/debian"
    rootfs=$1
    release=$2
    arch=$3
    mkdir -p $LOCALSTATEDIR/lock/subsys/
    (
        flock -x 9
        # shellcheck disable=SC2181
        if [ $? -ne 0 ]; then
            echo "Cache repository is busy."
            return 1
        fi

        echo "Checking cache download in $cache/rootfs-$release-$arch ... "
        if [ ! -e "$cache/rootfs-$release-$arch" ]; then
            download_debian "$cache" "$arch" "$release"
            # shellcheck disable=SC2181
            if [ $? -ne 0 ]; then
                echo "Failed to download 'debian base'"
                return 1
            fi
        fi

        copy_debian "$cache" "$arch" "$rootfs" "$release"
        # shellcheck disable=SC2181
        if [ $? -ne 0 ]; then
            echo "Failed to copy rootfs"
            return 1
        fi

        return 0

        ) 9>$LOCALSTATEDIR/lock/subsys/lxc-debian

    return $?
}

copy_configuration()
{
    path=$1
    rootfs=$2
    hostname=$3
    arch=$4

    # Generate the configuration file
    ## Create the fstab (empty by default)
    touch "$path/fstab"

    # if there is exactly one veth network entry, make sure it has an
    # associated hwaddr.
    # shellcheck disable=SC2126
    nics=$(grep -e '^lxc\.network\.type[ \t]*=[ \t]*veth' "$path/config" | wc -l)
    if [ "$nics" -eq 1 ]; then
        grep -q "^lxc.network.hwaddr" "$path/config" || sed -i -e "/^lxc\.network\.type[ \t]*=[ \t]*veth/a lxc.network.hwaddr = 00:16:3e:$(openssl rand -hex 3| sed 's/\(..\)/\1:/g; s/.$//')" "$path/config"
    fi

    ## Add all the includes
    echo "" >> "$path/config"
    echo "# Common configuration" >> "$path/config"
    if [ -e "${LXC_TEMPLATE_CONFIG}/debian.common.conf" ]; then
        echo "lxc.include = ${LXC_TEMPLATE_CONFIG}/debian.common.conf" >> "$path/config"
    fi
    if [ -e "${LXC_TEMPLATE_CONFIG}/debian.${release}.conf" ]; then
        echo "lxc.include = ${LXC_TEMPLATE_CONFIG}/debian.${release}.conf" >> "$path/config"
    fi

    ## Add the container-specific config
    echo "" >> "$path/config"
    echo "# Container specific configuration" >> "$path/config"
    grep -q "^lxc.rootfs" "$path/config" 2> /dev/null || echo "lxc.rootfs = $rootfs" >> "$path/config"

    cat <<EOF >> "$path/config"
lxc.mount = $path/fstab
lxc.utsname = $hostname
lxc.arch = $arch
EOF

    # shellcheck disable=SC2181
    if [ $? -ne 0 ]; then
        echo "Failed to add configuration"
        return 1
    fi

    return 0
}

clean()
{
    cache="$LOCALSTATEDIR/cache/lxc/debian"

    if [ ! -e $cache ]; then
        exit 0
    fi

    # lock, so we won't purge while someone is creating a repository
    (
        flock -x 9
        # shellcheck disable=SC2181
        if [ $? != 0 ]; then
            echo "Cache repository is busy."
            exit 1
        fi

        echo -n "Purging the download cache..."
        rm --preserve-root --one-file-system -rf $cache && echo "Done." || exit 1
        exit 0

    ) 9>$LOCALSTATEDIR/lock/subsys/lxc-debian
}

usage()
{
    cat <<EOF
$1 -h|--help -p|--path=<path> [-a|--arch] [-r|--release=<release>] [-c|--clean]
release: the debian release (e.g. wheezy): defaults to current stable
arch: the container architecture (e.g. amd64): defaults to host arch
EOF
    return 0
}

options=$(getopt -o hp:n:a:r:c -l help,rootfs:,path:,name:,arch:,release:,clean -- "$@")
# shellcheck disable=SC2181
if [ $? -ne 0 ]; then
        usage "$(basename "$0")"
        exit 1
fi
eval set -- "$options"

if which dpkg > /dev/null 2>&1 ; then
    arch=$(dpkg --print-architecture)
else
    arch=$(uname -m)
    if [ "$arch" = "i686" ]; then
        arch="i386"
    elif [ "$arch" = "x86_64" ]; then
        arch="amd64"
    elif [ "$arch" = "armv7l" ]; then
        arch="armhf"
    fi
fi
hostarch=$arch

while true
do
    case "$1" in
        -h|--help)      usage "$0" && exit 1;;
        -p|--path)      path=$2; shift 2;;
        --rootfs)       rootfs=$2; shift 2;;
        -a|--arch)      arch=$2; shift 2;;
        -r|--release)   release=$2; shift 2;;
        -n|--name)      name=$2; shift 2;;
        -c|--clean)     clean=$2; shift 1;;
        --)             shift 1; break ;;
        *)              break ;;
    esac
done

if [ ! -z "$clean" ] && [ -z "$path" ]; then
    clean || exit 1
    exit 0
fi

if [ "$arch" = "i686" ]; then
    arch=i386
fi

if [ "$arch" = "x86_64" ]; then
    arch=amd64
fi

if [ $hostarch = "i386" ] && [ $arch = "amd64" ]; then
    echo "can't create $arch container on $hostarch"
    exit 1
fi

if [ $hostarch = "armhf" ] || [ $hostarch = "armel" ] && \
   [ $arch != "armhf" ] && [ $arch != "armel" ]; then
    echo "can't create $arch container on $hostarch"
    exit 1
fi

if [ $hostarch = "powerpc" ] && [ $arch != "powerpc" ]; then
    echo "can't create $arch container on $hostarch"
    exit 1
fi

type debootstrap
# shellcheck disable=SC2181
if [ $? -ne 0 ]; then
    echo "'debootstrap' command is missing"
    exit 1
fi

if [ -z "$path" ]; then
    echo "'path' parameter is required"
    exit 1
fi

if [ "$(id -u)" != "0" ]; then
    echo "This script should be run as 'root'"
    exit 1
fi

current_release=$(wget "${MIRROR}/dists/stable/Release" -O - 2> /dev/null | head |awk '/^Codename: (.*)$/ { print $2; }')
release=${release:-${current_release}}
valid_releases=('squeeze' 'wheezy' 'jessie' 'sid')
if [[ ! "${valid_releases[*]}" =~ (^|[^[:alpha:]])$release([^[:alpha:]]|$) ]]; then
    echo "Invalid release ${release}, valid ones are: ${valid_releases[*]}"
    exit 1
fi

# detect rootfs
config="$path/config"
if [ -z "$rootfs" ]; then
    if grep -q '^lxc.rootfs' "$config" 2> /dev/null ; then
        rootfs=$(awk -F= '/^lxc.rootfs =/{ print $2 }' "$config")
    else
        rootfs=$path/rootfs
    fi
fi


install_debian "$rootfs" "$release" "$arch"
# shellcheck disable=SC2181
if [ $? -ne 0 ]; then
    echo "failed to install debian"
    exit 1
fi

configure_debian "$rootfs" "$name"
# shellcheck disable=SC2181
if [ $? -ne 0 ]; then
    echo "failed to configure debian for a container"
    exit 1
fi

copy_configuration "$path" "$rootfs" "$name" "$arch"
# shellcheck disable=SC2181
if [ $? -ne 0 ]; then
    echo "failed write configuration file"
    exit 1
fi

configure_debian_systemd "$path" "$rootfs"

if [ ! -z "$clean" ]; then
    clean || exit 1
    exit 0
fi
